package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLUnionSet_userImport) ENABLED START ***/
import java.util.Arrays;
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLUnionSet extends JNIObject implements IISLStandardSetMethods, IISLProjectionMethods {
	
	/* @generated */
	protected ISLUnionSet(long ptr) {
		/*** PROTECTED REGION ID(ISLUnionSet_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLUnionSet build(long ptr) {
		return new ISLUnionSet(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLUnionSet_userCode) ENABLED START ***/
	public String toString(ISL_FORMAT format) {
		return ISLPrettyPrinter.asString(this, format);
	}
	
//	@Override
	public ISLUnionSet projectOnto(ISLDimType dimType, int pos) {
		ISLUnionSet res = this.copy();
		int ndims = this.dim(dimType);
		if (pos < 0 || pos >= ndims)
			throw new IllegalArgumentException();
		if (pos>0)
			res = res.projectOut(dimType,0,pos);
		if (pos<ndims-1)
			res = res.projectOut(dimType,1,ndims-pos-1);
		return res;
	}
	
	public List<ISLSet> getSets() {
		List<ISLSet> res = new ArrayList<ISLSet>();
		for (int i = 0; i < getNbSets(); i++) {
			res.add(getSetAt(i));
		}
		return res;
	}

	public static ISLUnionSet buildFromSets(List<ISLSet> sets) {
		ISLUnionSet res = sets.get(0).toUnionSet();
		for (int i = 1; i < sets.size(); i++) {
			res.addSet(sets.get(i));
		}
		return res;
	}

	public static ISLUnionSet buildFromSets(ISLSet... sets) {
		return buildFromSets(Arrays.asList(sets));
	}
	
	/**
	 * Merge all Set in the union set as a single one, by ignoring tuple names.
	 * It assumes that all set have the same number of dimensions.
	 * 
	 * @return
	 */
	public ISLSet mergeAsSingleSet() {
		int nbdim = -1;
		ISLUnionSet uset = null;
		
		for (ISLSet aset : getSets()) {
			if (nbdim == -1) {
				nbdim = aset.getNbIndices();
			} else {
				if (aset.getNbIndices() != nbdim) {
					throw new UnsupportedOperationException(
							"Cannot merge sets with different number of input dimensions ("
									+ aset.getNbIndices() + " found, but " + nbdim
									+ " expected");
				}
			}
			
			if (uset == null) {
				uset = aset.clearTupleName().toUnionSet();
			} else {
				uset = uset.addSet(aset.clearTupleName());
			}
		}
		
		return uset.toSet();
	}
	
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	/**
	 * isl_union_set_read_from_str 
	 * 
	 * @generated
	**/
	 public static ISLUnionSet buildFromString(ISLContext ctx, String str) { 
		/*** PROTECTED REGION ID(static_isl_union_set_read_from_str) DISABLED START ***/
		ISLUnionSet res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLUnionSet.build(ISLNative.isl_union_set_read_from_str(getNativePtr(ctx), str));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_empty 
	 * 
	@take space
	 * @generated
	**/
	 public static ISLUnionSet buildEmpty(ISLSpace space) { 
		/*** PROTECTED REGION ID(static_isl_union_set_empty) DISABLED START ***/
		ISLUnionSet res;
		
		synchronized(LOCK) {
			checkParameters(space);
			try {
				res = ISLUnionSet.build(ISLNative.isl_union_set_empty(getNativePtr(space)));
			} finally {
				taken(space);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_universe 
	 * 
	@take uset
	 * @generated
	**/
	 public static ISLUnionSet buildUniverse(ISLUnionSet uset) { 
		/*** PROTECTED REGION ID(static_isl_union_set_universe) DISABLED START ***/
		ISLUnionSet res;
		
		synchronized(LOCK) {
			checkParameters(uset);
			try {
				res = ISLUnionSet.build(ISLNative.isl_union_set_universe(getNativePtr(uset)));
			} finally {
				taken(uset);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_to_string 
	 * 
	 * @generated
	**/
	 public static String _toString(ISLUnionSet map, int format) { 
		/*** PROTECTED REGION ID(static_isl_union_set_to_string) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_union_set_to_string(getNativePtr(map), format);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_set_from_union_set 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSet toSet() {
		/*** PROTECTED REGION ID(isl_set_from_union_set) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSet.build(ISLNative.isl_set_from_union_set(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_multi_aff_from_union_set 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionPWMultiAff toUnionPWMultiAff() {
		/*** PROTECTED REGION ID(isl_union_pw_multi_aff_from_union_set) DISABLED START ***/
		ISLUnionPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionPWMultiAff.build(ISLNative.isl_union_pw_multi_aff_from_union_set(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_get_ctx 
	 * 
	 * @generated
	**/
	public ISLContext getContext() {
		/*** PROTECTED REGION ID(isl_union_set_get_ctx) DISABLED START ***/
		ISLContext res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLContext.build(ISLNative.isl_union_set_get_ctx(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_get_space 
	 * 
	 * @generated
	**/
	public ISLSpace getSpace() {
		/*** PROTECTED REGION ID(isl_union_set_get_space) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLSpace.build(ISLNative.isl_union_set_get_space(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_copy 
	 * 
	 * @generated
	**/
	public ISLUnionSet copy() {
		/*** PROTECTED REGION ID(isl_union_set_copy) DISABLED START ***/
		ISLUnionSet res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLUnionSet.build(ISLNative.isl_union_set_copy(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_free 
	 * 
	 * @take this
	 * @generated
	**/
	public void free() {
		/*** PROTECTED REGION ID(isl_union_set_free) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				ISLNative.isl_union_set_free(getNativePtr(this));
			} finally {
				taken(this);
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_n_set 
	 * 
	 * @generated
	**/
	public int getNbSets() {
		/*** PROTECTED REGION ID(isl_union_set_n_set) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_union_set_n_set(getNativePtr(this));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_compute_divs 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionSet computeDivs() {
		/*** PROTECTED REGION ID(isl_union_set_compute_divs) DISABLED START ***/
		ISLUnionSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionSet.build(ISLNative.isl_union_set_compute_divs(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_extract_set 
	 * 
	 * @take space
	 * @generated
	**/
	public ISLSet extractSet(ISLSpace space) {
		/*** PROTECTED REGION ID(isl_union_set_extract_set) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(space);
			try {
				res = ISLSet.build(ISLNative.isl_union_set_extract_set(getNativePtr(this), getNativePtr(space)));
			} finally {
				taken(space);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_dim 
	 * 
	 * @generated
	**/
	public int dim(ISLDimType type) {
		/*** PROTECTED REGION ID(isl_union_set_dim) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_union_set_dim(getNativePtr(this), type.getValue());
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_is_empty 
	 * 
	 * @generated
	**/
	public boolean isEmpty() {
		/*** PROTECTED REGION ID(isl_union_set_is_empty) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_union_set_is_empty(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_is_params 
	 * 
	 * @generated
	**/
	public boolean isParamSet() {
		/*** PROTECTED REGION ID(isl_union_set_is_params) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_union_set_is_params(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_sample_point 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLPoint samplePoint() {
		/*** PROTECTED REGION ID(isl_union_set_sample_point) DISABLED START ***/
		ISLPoint res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLPoint.build(ISLNative.isl_union_set_sample_point(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_is_equal 
	 * 
	 * @generated
	**/
	public boolean isEqual(ISLUnionSet uset2) {
		/*** PROTECTED REGION ID(isl_union_set_is_equal) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_union_set_is_equal(getNativePtr(this), getNativePtr(uset2)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_is_disjoint 
	 * 
	 * @generated
	**/
	public boolean isDisjoint(ISLUnionSet uset2) {
		/*** PROTECTED REGION ID(isl_union_set_is_disjoint) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_union_set_is_disjoint(getNativePtr(this), getNativePtr(uset2)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_is_subset 
	 * 
	 * @generated
	**/
	public boolean isSubset(ISLUnionSet uset2) {
		/*** PROTECTED REGION ID(isl_union_set_is_subset) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_union_set_is_subset(getNativePtr(this), getNativePtr(uset2)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_is_strict_subset 
	 * 
	 * @generated
	**/
	public boolean isStrictSubset(ISLUnionSet uset2) {
		/*** PROTECTED REGION ID(isl_union_set_is_strict_subset) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_union_set_is_strict_subset(getNativePtr(this), getNativePtr(uset2)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_project_out 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionSet projectOut(ISLDimType type, int first, int n) {
		/*** PROTECTED REGION ID(isl_union_set_project_out) DISABLED START ***/
		ISLUnionSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionSet.build(ISLNative.isl_union_set_project_out(getNativePtr(this), type.getValue(), first, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_params 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSet params() {
		/*** PROTECTED REGION ID(isl_union_set_params) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSet.build(ISLNative.isl_union_set_params(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_identity 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionMap identity() {
		/*** PROTECTED REGION ID(isl_union_set_identity) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_set_identity(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_coalesce 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionSet coalesce() {
		/*** PROTECTED REGION ID(isl_union_set_coalesce) DISABLED START ***/
		ISLUnionSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionSet.build(ISLNative.isl_union_set_coalesce(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_detect_equalities 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionSet detectEqualities() {
		/*** PROTECTED REGION ID(isl_union_set_detect_equalities) DISABLED START ***/
		ISLUnionSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionSet.build(ISLNative.isl_union_set_detect_equalities(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_remove_redundancies 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionSet removeRedundancies() {
		/*** PROTECTED REGION ID(isl_union_set_remove_redundancies) DISABLED START ***/
		ISLUnionSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionSet.build(ISLNative.isl_union_set_remove_redundancies(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_affine_hull 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionSet affineHull() {
		/*** PROTECTED REGION ID(isl_union_set_affine_hull) DISABLED START ***/
		ISLUnionSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionSet.build(ISLNative.isl_union_set_affine_hull(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_polyhedral_hull 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionSet polyhedralHull() {
		/*** PROTECTED REGION ID(isl_union_set_polyhedral_hull) DISABLED START ***/
		ISLUnionSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionSet.build(ISLNative.isl_union_set_polyhedral_hull(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_wrapped_domain_map 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionMap wrappedDomainMap() {
		/*** PROTECTED REGION ID(isl_union_set_wrapped_domain_map) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_set_wrapped_domain_map(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_unwrap 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionMap unwrap() {
		/*** PROTECTED REGION ID(isl_union_set_unwrap) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_set_unwrap(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_lift 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionSet lift() {
		/*** PROTECTED REGION ID(isl_union_set_lift) DISABLED START ***/
		ISLUnionSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionSet.build(ISLNative.isl_union_set_lift(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_add_set 
	 * 
	 * @take this set
	 * @generated
	**/
	public ISLUnionSet addSet(ISLSet set) {
		/*** PROTECTED REGION ID(isl_union_set_add_set) DISABLED START ***/
		ISLUnionSet res;
		
		synchronized(LOCK) {
			checkParameters(this, set);
			try {
				res = ISLUnionSet.build(ISLNative.isl_union_set_add_set(getNativePtr(this), getNativePtr(set)));
			} finally {
				taken(this);
				taken(set);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_intersect_params 
	 * 
	 * @take this set
	 * @generated
	**/
	public ISLUnionSet intersectParams(ISLSet set) {
		/*** PROTECTED REGION ID(isl_union_set_intersect_params) DISABLED START ***/
		ISLUnionSet res;
		
		synchronized(LOCK) {
			checkParameters(this, set);
			try {
				res = ISLUnionSet.build(ISLNative.isl_union_set_intersect_params(getNativePtr(this), getNativePtr(set)));
			} finally {
				taken(this);
				taken(set);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_intersect 
	 * 
	 * @take this uset2
	 * @generated
	**/
	public ISLUnionSet intersect(ISLUnionSet uset2) {
		/*** PROTECTED REGION ID(isl_union_set_intersect) DISABLED START ***/
		ISLUnionSet res;
		
		synchronized(LOCK) {
			checkParameters(this, uset2);
			try {
				res = ISLUnionSet.build(ISLNative.isl_union_set_intersect(getNativePtr(this), getNativePtr(uset2)));
			} finally {
				taken(this);
				taken(uset2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_union 
	 * 
	 * @take this uset2
	 * @generated
	**/
	public ISLUnionSet union(ISLUnionSet uset2) {
		/*** PROTECTED REGION ID(isl_union_set_union) DISABLED START ***/
		ISLUnionSet res;
		
		synchronized(LOCK) {
			checkParameters(this, uset2);
			try {
				res = ISLUnionSet.build(ISLNative.isl_union_set_union(getNativePtr(this), getNativePtr(uset2)));
			} finally {
				taken(this);
				taken(uset2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_subtract 
	 * 
	 * @take this uset2
	 * @generated
	**/
	public ISLUnionSet subtract(ISLUnionSet uset2) {
		/*** PROTECTED REGION ID(isl_union_set_subtract) DISABLED START ***/
		ISLUnionSet res;
		
		synchronized(LOCK) {
			checkParameters(this, uset2);
			try {
				res = ISLUnionSet.build(ISLNative.isl_union_set_subtract(getNativePtr(this), getNativePtr(uset2)));
			} finally {
				taken(this);
				taken(uset2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_apply 
	 * 
	 * @take this umap
	 * @generated
	**/
	public ISLUnionSet apply(ISLUnionMap umap) {
		/*** PROTECTED REGION ID(isl_union_set_apply) DISABLED START ***/
		ISLUnionSet res;
		
		synchronized(LOCK) {
			checkParameters(this, umap);
			try {
				res = ISLUnionSet.build(ISLNative.isl_union_set_apply(getNativePtr(this), getNativePtr(umap)));
			} finally {
				taken(this);
				taken(umap);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_preimage_multi_aff 
	 * 
	 * @take this ma
	 * @generated
	**/
	public ISLUnionSet preimage(ISLMultiAff ma) {
		/*** PROTECTED REGION ID(isl_union_set_preimage_multi_aff) DISABLED START ***/
		ISLUnionSet res;
		
		synchronized(LOCK) {
			checkParameters(this, ma);
			try {
				res = ISLUnionSet.build(ISLNative.isl_union_set_preimage_multi_aff(getNativePtr(this), getNativePtr(ma)));
			} finally {
				taken(this);
				taken(ma);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_preimage_pw_multi_aff 
	 * 
	 * @take this pma
	 * @generated
	**/
	public ISLUnionSet preimage(ISLPWMultiAff pma) {
		/*** PROTECTED REGION ID(isl_union_set_preimage_pw_multi_aff) DISABLED START ***/
		ISLUnionSet res;
		
		synchronized(LOCK) {
			checkParameters(this, pma);
			try {
				res = ISLUnionSet.build(ISLNative.isl_union_set_preimage_pw_multi_aff(getNativePtr(this), getNativePtr(pma)));
			} finally {
				taken(this);
				taken(pma);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_preimage_union_pw_multi_aff 
	 * 
	 * @take this upma
	 * @generated
	**/
	public ISLUnionSet preimage(ISLUnionPWMultiAff upma) {
		/*** PROTECTED REGION ID(isl_union_set_preimage_union_pw_multi_aff) DISABLED START ***/
		ISLUnionSet res;
		
		synchronized(LOCK) {
			checkParameters(this, upma);
			try {
				res = ISLUnionSet.build(ISLNative.isl_union_set_preimage_union_pw_multi_aff(getNativePtr(this), getNativePtr(upma)));
			} finally {
				taken(this);
				taken(upma);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_product 
	 * 
	 * @take this uset2
	 * @generated
	**/
	public ISLUnionSet product(ISLUnionSet uset2) {
		/*** PROTECTED REGION ID(isl_union_set_product) DISABLED START ***/
		ISLUnionSet res;
		
		synchronized(LOCK) {
			checkParameters(this, uset2);
			try {
				res = ISLUnionSet.build(ISLNative.isl_union_set_product(getNativePtr(this), getNativePtr(uset2)));
			} finally {
				taken(this);
				taken(uset2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_gist 
	 * 
	 * @take this context
	 * @generated
	**/
	public ISLUnionSet gist(ISLUnionSet context) {
		/*** PROTECTED REGION ID(isl_union_set_gist) DISABLED START ***/
		ISLUnionSet res;
		
		synchronized(LOCK) {
			checkParameters(this, context);
			try {
				res = ISLUnionSet.build(ISLNative.isl_union_set_gist(getNativePtr(this), getNativePtr(context)));
			} finally {
				taken(this);
				taken(context);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_gist_params 
	 * 
	 * @take this set
	 * @generated
	**/
	public ISLUnionSet gistParams(ISLSet set) {
		/*** PROTECTED REGION ID(isl_union_set_gist_params) DISABLED START ***/
		ISLUnionSet res;
		
		synchronized(LOCK) {
			checkParameters(this, set);
			try {
				res = ISLUnionSet.build(ISLNative.isl_union_set_gist_params(getNativePtr(this), getNativePtr(set)));
			} finally {
				taken(this);
				taken(set);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_lexmin 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionSet lexMin() {
		/*** PROTECTED REGION ID(isl_union_set_lexmin) DISABLED START ***/
		ISLUnionSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionSet.build(ISLNative.isl_union_set_lexmin(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_lexmax 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionSet lexMax() {
		/*** PROTECTED REGION ID(isl_union_set_lexmax) DISABLED START ***/
		ISLUnionSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionSet.build(ISLNative.isl_union_set_lexmax(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_get_set_at 
	 * 
	 * @generated
	**/
	public ISLSet getSetAt(int pos) {
		/*** PROTECTED REGION ID(isl_union_set_get_set_at) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLSet.build(ISLNative.isl_union_set_get_set_at(getNativePtr(this), pos));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLUnionSet_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
